/* 2ndIndex zu 1stGuide, dem Hypertextsystem von Guido Vollbeding
 * 2ndIndex von Dirk Haun, 30.04./01.05.1993 (Pure C 1.1)
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define TRUE        (1)
#define FALSE       (0)
#define forever     while(1==1)

/* Prototypes */
int make_index(void);
int merke_stichwort(char *wort);
int merke_datei(char *datei);

/* globale Variablen */
FILE *fp;
char *stwbase=0L, *datbase=0L;
char *nextfile=0L;
char refpath[255];
int refpos=-1;

int main(int argc,char *argv[])
{
 int ret=1;
 char *xp, fullpath[128];

 if(argc>1)
 {
  strcpy(fullpath,argv[1]);
  if(strrchr(fullpath,'\\')==0L) fprintf(stderr,"2ndindex: Bitte kompletten Pfadnamen angeben.\n\n");
  else
  {
   forever
   {
    fp=fopen(fullpath,"rb");
    if(fp)
    {
     strcpy(refpath,fullpath);
     xp=strrchr(refpath,'\\');
     *(xp+1)='\0';
     if(refpos<0) refpos=(int)strlen(refpath);
     if(make_index())
     {
      fclose(fp);
      if(datbase && stwbase)
      {
       if(nextfile==0L) nextfile=datbase+4;
       nextfile=(*(char**)(nextfile-4));
       if(nextfile)
       {
        nextfile+=4;
        strcpy(fullpath,nextfile);
       }
       else /* fertig! */
       {
        ret=0;
        fprintf(stderr,"2ndindex: Operation erfolgreich abgeschlossen.\n\n");
        break;
       }
      }
      else
      {
       fprintf(stderr,"2ndindex: Keine Stichwrter gefunden.\n\n");
       break;
      }
     }
     else
     {
      fclose(fp);
      break;
     }
    }
    else
    {
     fprintf(stderr,"2ndindex: Konnte Datei %s nicht ffnen!\n\n",fullpath);
     break;
    }
   }
  }
 }
 else fprintf(stderr,"2ndindex [pfadname] [>output]\n\n");
 return(ret);
}

int make_index(void)
{
 int i, c, ret=FALSE;
 char *cp, wort[255], datei[255], pfad[255];

 forever
 {
  c=fgetc(fp);
  if(c==EOF)
  {
   ret=TRUE;
   break;
  }
  else if(c==(unsigned char)'')
  {
   i=0;
   forever
   {
    c=fgetc(fp);
    if(c==EOF || c==(unsigned char)'') break;
    wort[i++]=c;
   }
   wort[i]='\0';
   if(c==EOF) break;
   i=0;
   forever
   {
    c=fgetc(fp);
    if(c==EOF || c==(unsigned char)'') break;
    datei[i++]=c;
   }
   datei[i]='\0';
   if(c==EOF) break;
   if(merke_stichwort(wort))
   {
    strcpy(pfad,refpath);
    if(strncmp(datei,"..\\",3)==0)
    {
     cp=strrchr(pfad,'\\');
     while(*--cp!='\\');
     strcpy(cp,datei+2);
    }
    else strcat(pfad,datei);
    printf("\t%s%s\n",wort,pfad+refpos);
    merke_datei(pfad);
   }
  }
 }
 return(ret);
}

int merke_stichwort(char *wort)
{
 int found=FALSE, ret=FALSE;
 char *nw, **cp;

 if(stwbase)
 {
  nw=stwbase;
  while(nw)
  {
   if(strcmp(nw+4,wort)==0)
   {
    found=TRUE;
    break;
   }
   nw=*(char**)nw;
  }
 }
 if(!found)
 {
  nw=malloc(strlen(wort)+1+4); /* Lnge des Wortes + Nullbyte + Zeiger */
  if(nw)
  {
   *(long*)nw=0L;
   strcpy(nw+4,wort);
   if(stwbase==0L) stwbase=nw;
   else
   {
    cp=(char**)stwbase;
    while(*cp) cp=(char**)*cp;
    *cp=nw;
   }
   ret=TRUE;
  }
 }
 return(ret);
}

int merke_datei(char *datei)
{
 int found=FALSE, ret=FALSE;
 char *nd, **cp;

 if(datbase)
 {
  nd=datbase;
  while(nd)
  {
   if(strcmp(nd+4,datei)==0)
   {
    found=TRUE;
     break;
   }
   nd=*(char**)nd;
  }
 }
 if(!found)
 {
  nd=malloc(strlen(datei)+1+4); /* Lnge des Dateinamens + Nullbyte + Zeiger */
  if(nd)
  {
   *(long*)nd=0L;
   strcpy(nd+4,datei);
   if(datbase==0L) datbase=nd;
   else
   {
    cp=(char**)datbase;
    while(*cp) cp=(char**)*cp;
    *cp=nd;
   }
   ret=TRUE;
  }
 }
 return(ret);
}
